'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _compose = require('recompose/compose');

var _compose2 = _interopRequireDefault(_compose);

var _Menu = require('material-ui/Menu');

var _PowerSettingsNew = require('material-ui-icons/PowerSettingsNew');

var _PowerSettingsNew2 = _interopRequireDefault(_PowerSettingsNew);

var _translate = require('../../i18n/translate');

var _translate2 = _interopRequireDefault(_translate);

var _authActions = require('../../actions/authActions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var iconPaddingStyle = { paddingRight: '0.5em' };

var Logout = function Logout(_ref) {
    var translate = _ref.translate,
        userLogout = _ref.userLogout;
    return _react2.default.createElement(
        _Menu.MenuItem,
        { className: 'logout', onClick: userLogout },
        _react2.default.createElement(_PowerSettingsNew2.default, { style: iconPaddingStyle }),
        translate('ra.auth.logout')
    );
};

Logout.propTypes = {
    translate: _propTypes2.default.func,
    userLogout: _propTypes2.default.func
};

var mapStateToProps = function mapStateToProps(state) {
    return {
        theme: state.theme
    };
};

var enhance = (0, _compose2.default)(_translate2.default, (0, _reactRedux.connect)(mapStateToProps, { userLogout: _authActions.userLogout }));

exports.default = enhance(Logout);
module.exports = exports['default'];