'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _shouldUpdate = require('recompose/shouldUpdate');

var _shouldUpdate2 = _interopRequireDefault(_shouldUpdate);

var _compose = require('recompose/compose');

var _compose2 = _interopRequireDefault(_compose);

var _Button = require('material-ui/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Create = require('material-ui-icons/Create');

var _Create2 = _interopRequireDefault(_Create);

var _styles = require('material-ui/styles');

var _Link = require('../Link');

var _Link2 = _interopRequireDefault(_Link);

var _linkToRecord = require('../../util/linkToRecord');

var _linkToRecord2 = _interopRequireDefault(_linkToRecord);

var _translate = require('../../i18n/translate');

var _translate2 = _interopRequireDefault(_translate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
    link: {
        display: 'inline-flex',
        alignItems: 'center'
    }
};

var EditButton = function EditButton(_ref) {
    var _ref$basePath = _ref.basePath,
        basePath = _ref$basePath === undefined ? '' : _ref$basePath,
        _ref$classes = _ref.classes,
        classes = _ref$classes === undefined ? {} : _ref$classes,
        _ref$label = _ref.label,
        label = _ref$label === undefined ? 'ra.action.edit' : _ref$label,
        _ref$record = _ref.record,
        record = _ref$record === undefined ? {} : _ref$record,
        translate = _ref.translate;
    return _react2.default.createElement(
        _Button2.default,
        { color: 'primary' },
        _react2.default.createElement(
            _Link2.default,
            { to: (0, _linkToRecord2.default)(basePath, record.id), className: classes.link },
            _react2.default.createElement(_Create2.default, null),
            '\xA0',
            label && translate(label)
        )
    );
};

EditButton.propTypes = {
    basePath: _propTypes2.default.string,
    classes: _propTypes2.default.object,
    label: _propTypes2.default.string,
    record: _propTypes2.default.object,
    translate: _propTypes2.default.func.isRequired
};

var enhance = (0, _compose2.default)((0, _shouldUpdate2.default)(function (props, nextProps) {
    return props.record && props.record.id !== nextProps.record.id || props.basePath !== nextProps.basePath || props.record == null && nextProps.record != null;
}), (0, _styles.withStyles)(styles), _translate2.default);

exports.default = enhance(EditButton);
module.exports = exports['default'];