'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Menu = require('material-ui/Menu');

var _Dashboard = require('material-ui-icons/Dashboard');

var _Dashboard2 = _interopRequireDefault(_Dashboard);

var _styles = require('material-ui/styles');

var _Link = require('../Link');

var _Link2 = _interopRequireDefault(_Link);

var _translate = require('../../i18n/translate');

var _translate2 = _interopRequireDefault(_translate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var iconPaddingStyle = { paddingRight: '0.5em' };

var styles = {
    link: {
        display: 'flex',
        alignItems: 'center',
        textDecoration: 'none',
        color: 'inherit'
    }
};

var DashboardMenuItem = function DashboardMenuItem(_ref) {
    var classes = _ref.classes,
        onClick = _ref.onClick,
        translate = _ref.translate;
    return _react2.default.createElement(
        _Menu.MenuItem,
        { onClick: onClick },
        _react2.default.createElement(
            _Link2.default,
            { to: '/', className: classes.link },
            _react2.default.createElement(_Dashboard2.default, { style: iconPaddingStyle }),
            translate('ra.page.dashboard')
        )
    );
};

DashboardMenuItem.propTypes = {
    classes: _propTypes2.default.object,
    onClick: _propTypes2.default.func,
    translate: _propTypes2.default.func.isRequired
};

exports.default = (0, _styles.withStyles)(styles)((0, _translate2.default)(DashboardMenuItem));
module.exports = exports['default'];