'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.LinearProgress = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Progress = require('material-ui/Progress');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('material-ui/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = function styles(theme) {
    return {
        root: {
            margin: theme.spacing.unit + 'px 0',
            width: theme.spacing.unit * 20 + 'px'
        }
    };
};

/**
 * Progress bar formatted to replace an input or a field in a form layout
 * 
 * Avoids visual jumps when replaced by value or form input
 * 
 * @see ReferenceField
 * @see ReferenceInput
 * 
 * @param {object} classes CSS class names injected by withStyles 
 */
var LinearProgress = exports.LinearProgress = function LinearProgress(_ref) {
    var classes = _ref.classes;
    return _react2.default.createElement(_Progress.LinearProgress, { className: classes.root });
};
LinearProgress.propTypes = {
    classes: _propTypes2.default.object
};

exports.default = (0, _styles.withStyles)(styles)(LinearProgress);